diff --git a/packages/visualgst/Widget/HBox.st b/packages/visualgst/Widget/HBox.st
new file mode 100644
index 0000000..f67fc0a
--- /dev/null
+++ b/packages/visualgst/Widget/HBox.st
@@ -0,0 +1,44 @@
+"======================================================================
+|
+| HBox class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+Box subclass: HBox [
+
+    box [
+        <category: 'accessing'>
+
+        ^ GTK.GtkHBox
+    ]
+]
+
diff --git a/packages/visualgst/Widget/HPaned.st b/packages/visualgst/Widget/HPaned.st
new file mode 100644
index 0000000..e73fbdf
--- /dev/null
+++ b/packages/visualgst/Widget/HPaned.st
@@ -0,0 +1,44 @@
+"======================================================================
+|
+| HPaned class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+Paned subclass: HPaned [
+
+    paned [
+        <category: 'accessing'>
+
+        ^ GTK.GtkHPaned
+    ]
+]
+
diff --git a/packages/visualgst/Widget/HSidebar.st b/packages/visualgst/Widget/HSidebar.st
new file mode 100644
index 0000000..5fb4a39
--- /dev/null
+++ b/packages/visualgst/Widget/HSidebar.st
@@ -0,0 +1,43 @@
+"======================================================================
+|
+| HSideBarWidget class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+Sidebar subclass: HSidebar [
+
+    panedOrientation [
+
+	^ GTK.GtkHPaned
+    ]
+]
+
diff --git a/packages/visualgst/Widget/Label.st b/packages/visualgst/Widget/Label.st
new file mode 100644
index 0000000..4b5b160
--- /dev/null
+++ b/packages/visualgst/Widget/Label.st
@@ -0,0 +1,59 @@
+"======================================================================
+|
+| Label class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+Widget subclass: Label [
+
+    Label class >> text: aString [
+        <category: 'instance creation'>
+
+        ^ self new
+            text: aString;
+            yourself
+    ]
+
+    initialize [
+        <category: 'initialization'>
+
+        child := GTK.GtkLabel new.
+        super initialize.
+    ]
+
+    text: aString [
+        <category: 'accessing'>
+
+        child setText: aString
+    ]
+]
+
diff --git a/packages/visualgst/Widget/List.st b/packages/visualgst/Widget/List.st
new file mode 100644
index 0000000..7ede3fc
--- /dev/null
+++ b/packages/visualgst/Widget/List.st
@@ -0,0 +1,178 @@
+"======================================================================
+|
+| List class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+Widget subclass: List [
+
+    | list model |
+
+    List class >> column: anArray contents: aOneArgBlock [
+        <category: 'instance creation'>
+
+        ^ self new
+            column: anArray contents: aOneArgBlock;
+            yourself        
+    ]
+
+    initialize [
+        <category: 'initialization'>
+
+    ]
+
+    column: anArray contents: aOneArgBlock [
+        <category: 'initialization'>
+
+        list := GTK.GtkTreeView createListWithModel: anArray.
+        model := GtkListModel on: list getModel.
+        self contents: aOneArgBlock.
+        child := GTK.GtkScrolledWindow withChild: list.
+        super initialize.
+    ]
+
+    contents: aOneArgBlock [
+
+        model contentsBlock: aOneArgBlock.
+    ]
+
+    item: anObject [
+
+        model item: anObject
+    ]
+
+    refresh [
+
+        model refresh
+    ]
+
+    clear [
+
+        model clear
+    ]
+
+    selectAt: anIndex [
+
+        list selectNth: anIndex
+    ]
+
+    selection [
+
+        ^ list selection
+    ]
+
+    selectionIndex [
+
+        ^ list selectedIndex
+    ]
+
+    hasSelection [
+
+        ^ list hasSelectedItem
+    ]
+
+    select: anObject [
+
+        ^ list select: anObject
+    ]
+
+    selectFirstItem [
+
+        ^ list selectFirstItem
+    ]
+
+    selectLastItem [
+
+        ^ list selectLastItem
+    ]
+
+    unselectAll [
+
+        list unselectAll
+    ]
+
+    noSelection [
+
+        list getSelection setMode: GTK.Gtk gtkSelectionNone
+    ]
+
+    zeroOrOneSelection [
+
+        list getSelection setMode: GTK.Gtk gtkSelectionSingle
+    ]
+
+    singleSelection [
+
+        list getSelection setMode: GTK.Gtk gtkSelectionBrowse
+    ]
+
+    multipleSelection [
+
+        list getSelection setMode: GTK.Gtk gtkSelectionMultiple
+    ]
+
+    popupMenu: aMenuBuilder [
+        <category: 'user interface'>
+
+        popupMenu := aMenuBuilder.
+        list connectSignal: 'button-press-event' to: self selector: #'onPress:event:'
+    ]
+
+    whenButtonPressedSend: aSymbol to: anObject [
+
+        list connectSignal: 'button-press-event' to: anObject selector: aSymbol
+    ]
+
+    whenSelectionChangedSend: aSymbol to: anObject [
+
+        list getSelection connectSignal: 'changed' to: anObject selector: aSymbol
+    ]
+
+    onPress: aGtkWidget event: aGdkEvent [
+        <category: 'button event'>
+
+        | menu aGdkButtonEvent |
+        aGdkButtonEvent := aGdkEvent castTo: GTK.GdkEventButton type.
+        aGdkButtonEvent button value = 3 ifFalse: [ ^ false ].
+        menu := popupMenu asPopupMenu.
+        menu attachToWidget: list detacher: nil.
+        menu popup: nil parentMenuItem: nil func: nil data: nil button: 3 activateTime: aGdkButtonEvent time value.
+        menu showAll.
+        ^ true
+    ]
+
+    list [
+
+        ^ list
+    ]
+]
+
diff --git a/packages/visualgst/Widget/Notebook.st b/packages/visualgst/Widget/Notebook.st
new file mode 100644
index 0000000..fd8c2d4
--- /dev/null
+++ b/packages/visualgst/Widget/Notebook.st
@@ -0,0 +1,187 @@
+"======================================================================
+|
+| Notebook class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+Widget subclass: Notebook [
+
+    | currentWidget selectMessage pages labels |
+
+    initialize [
+	<category: 'initialization'>
+
+	labels := OrderedCollection new.
+	pages := OrderedCollection new.
+        child := self buildNotebookWidget.
+        super initialize.
+    ]
+
+    buildNotebookWidget [
+	<category: 'private initialization'>
+
+        ^ GTK.GtkNotebook new
+		    connectSignal: 'switch-page' to: self selector: #'switchPageOn:page:number:';
+		    setShowTabs: false;
+		    yourself
+    ]
+
+    whenSelectionChangedSend: aSymbol to: anObject [
+        <category: 'events'>
+
+        selectMessage := DirectedMessage receiver: anObject selector: aSymbol arguments: #()
+    ]
+
+    addWidget: aWidget label: aString [
+	<category: 'user interface'>
+
+	self addWidget: aWidget labelWidget: (self buildLabelWidget: aString withIcon: GTK.Gtk gtkStockClose at: aWidget)
+    ]
+
+
+    updateWidget: aWidget label: aString [
+	<category: 'user interface'>
+
+	child setTabLabel: aWidget mainWidget tabLabel: (self buildLabelWidget: aString withIcon: GTK.Gtk gtkStockClose at: aWidget)
+    ]
+
+    addPermanentWidget: aWidget label: aString [
+        <category: 'user interface'>
+
+	self addWidget: aWidget labelWidget: (labels add: (Label text: aString) mainWidget)
+    ]
+
+    addWidget: aWidget labelWidget: aLabelWidget [
+	<category: 'private'>
+
+	currentWidget ifNil: [ currentWidget := aWidget ].
+        pages addLast: aWidget.
+        child appendPage: aWidget mainWidget tabLabel: aLabelWidget.
+        pages size > 1 ifTrue: [ child setShowTabs: true ]
+    ]
+
+    buildLabelWidget: aString withIcon: aStockString at: aSmallInteger [
+        <category: 'private'>
+
+        | image close |
+        image := GTK.GtkImage newFromStock: aStockString size: GTK.Gtk gtkIconSizeMenu.
+        close := (GTK.GtkButton new)
+                    setImage: image;
+                    setRelief: GTK.Gtk gtkReliefNone;
+                    connectSignal: 'pressed' to: self selector: #'closeIt:at:' userData: aSmallInteger;
+                    yourself.
+        ^ (GTK.GtkHBox new: false spacing: 0)
+            add: (labels add: (Label text: aString) mainWidget);
+            add: close;
+            showAll;
+            yourself
+    ]
+
+    switchPageOn: aGtkNotebook page: aGtkNotebookPage number: anInteger [
+        <category: 'notebook events'>
+
+        currentWidget := pages at: anInteger + 1.
+        selectMessage ifNotNil: [ selectMessage send ]
+    ]
+
+    closeIt: aGtkButton  at: aGtkConcreteWidget [
+        <category: 'notebook events'>
+
+        | pageNb |
+        pageNb := child pageNum: aGtkConcreteWidget mainWidget.
+	aGtkConcreteWidget close.
+        pages removeAtIndex: pageNb + 1.
+	labels removeAtIndex: pageNb + 1.
+        child removePage: pageNb.
+	pages size = 1 ifTrue: [ child setShowTabs: false ]
+    ]
+
+    widgetAt: anInteger [
+	<category: 'accessing'>
+
+	^ pages at: anInteger
+    ]
+
+    currentWidget [
+	<category: 'accessing'>
+
+	^ currentWidget
+    ]
+
+    focusedWidget [
+	<category: 'accessing'>
+
+	^ currentWidget focusedWidget
+    ]
+
+    currentPage [
+	<category: 'pages'>
+
+	^ child getCurrentPage
+    ]
+
+    currentPage: aSmallInteger [
+	<category: 'pages'>
+
+	child setCurrentPage: aSmallInteger
+    ]
+
+    showLastPage [
+	<category: 'pages'>
+
+	self currentPage: self numberOfPages - 1
+    ]
+
+    numberOfPages [
+	<category: 'pages'>
+
+	^ child getNPages
+    ]
+
+    closeCurrentPage [
+	<category: 'pages'>
+
+	self numberOfPages = 1 ifTrue: [ ^ self ].
+        pages removeAtIndex: self currentPage + 1.
+	labels removeAtIndex: self currentPage + 1.
+	child removePage: self currentPage.
+	pages size = 1 ifTrue: [ child setShowTabs: false ]
+    ]
+
+    showPane [
+	<category: 'widget'>
+
+	child showAll.
+	pages do: [ :each | each postInitialize ]
+    ]
+]
+
diff --git a/packages/visualgst/Widget/Paned.st b/packages/visualgst/Widget/Paned.st
new file mode 100644
index 0000000..5f41ad0
--- /dev/null
+++ b/packages/visualgst/Widget/Paned.st
@@ -0,0 +1,122 @@
+"======================================================================
+|
+| Paned class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+Widget subclass: Paned [
+
+    Paned class >> with: aWidget [
+        <category: 'instance creation'>
+
+        ^ self new
+            first: aWidget;
+            yourself
+    ]
+
+    Paned class >> with: aWidget1 with: aWidget2 [
+        <category: 'instance creation'>
+
+        ^ self new
+            first: aWidget1;
+            second: aWidget2;
+            yourself
+    ]
+
+    Paned class >> addAll: anArray [
+	<category: 'instance creation'>
+
+        ^ self addAll: anArray from: 1
+    ]
+
+    Paned class >> addAll: anArray from: anInteger [
+	<category: 'instance creation'>
+
+        ^ anArray size - anInteger = 0
+                ifTrue: [ self with: (anArray at: anInteger) ]
+                ifFalse: [
+                    anArray size - anInteger > 1 ifTrue: [
+                                            self with: (anArray at: anInteger) with: (self addAll: anArray from: anInteger + 1) ]
+                                    ifFalse: [ self with: (anArray at: anInteger) with: (anArray at: anInteger + 1) ] ]
+    ]
+
+    | firstWidget secondWidget |
+
+    initialize [
+        <category: 'initialization'>
+
+        child := self paned new.
+        super initialize.
+    ]
+
+    first: aWidget [
+        <category: 'accessing'>
+
+        child pack1: (firstWidget := aWidget) mainWidget resize: true shrink: true
+    ]
+
+    first [
+        <category: 'accessing'>
+
+        ^ firstWidget
+    ]
+
+    second: aWidget [
+        <category: 'accessing'>
+
+        child pack2: (secondWidget := aWidget) mainWidget resize: true shrink: true
+    ]
+
+    second [
+        <category: 'accessing'>
+
+        ^ secondWidget
+    ]
+
+    position: anInteger [
+        <category: 'accessing'>
+
+        child setPosition: anInteger
+    ]
+
+    position [
+        <category: 'accessing'>
+
+        ^ child getPosition
+    ]
+
+    paned [
+        <category: 'accessing'>
+
+    ]
+]
+
diff --git a/packages/visualgst/Widget/Sidebar.st b/packages/visualgst/Widget/Sidebar.st
new file mode 100644
index 0000000..34f887f
--- /dev/null
+++ b/packages/visualgst/Widget/Sidebar.st
@@ -0,0 +1,123 @@
+"======================================================================
+|
+| Sidebar class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+Widget subclass: Sidebar [
+
+    | activeWidget widgets widgetEvents |
+
+    initialize [
+	<category: 'initialization'>
+
+	child := GTK.GtkNotebook new
+				setTabPos: GTK.Gtk gtkPosBottom;
+				connectSignal: 'switch-page' to: self selector: #'switchPageOn:page:number:';
+				yourself.
+	widgetEvents := Dictionary new.
+	widgets := OrderedCollection new
+    ]
+
+    add: aWidget labeled: aString [
+	<category: 'notebook'>
+
+	child appendPage: aWidget mainWidget tabLabel: (Label text: aString) mainWidget.
+	widgets add: aWidget
+    ]
+
+    addAll: anArray [
+	<category: 'notebook'>
+
+	anArray do: [ :each | self add: each key labeled: each value ]
+    ]
+
+    show: anIndex [
+	<category: 'notebook'>
+
+	activeWidget ifNotNil: [ :aWidget | aWidget hideAll ].
+	child showAll.
+	child setCurrentPage: anIndex - 1.
+	activeWidget := (widgets at: anIndex)
+					showAll;
+					yourself
+    ]
+
+    showAll [
+	<category: 'notebook'>
+
+	child show
+    ]
+
+    hideTabs [
+	<category: 'notebook'>
+
+	child setShowTabs: false
+    ]
+
+    hide [
+	<category: 'notebook'>
+
+	self hideMainPained
+    ]
+
+    hideAll [
+	<category: 'notebook'>
+
+	self hideMainPained
+    ]
+
+    hideMainPained [
+	<category: 'notebook'>
+
+	child hideAll
+    ]
+
+    panedOrientation [
+	<category: 'accessing'>
+
+	^ self subclassResponsibility
+    ]
+
+    switchPageOn: aGtkNotebook page: aGtkNotebookPage number: anInteger [
+        <category: 'notebook events'>
+
+	widgetEvents at: (child getNthPage: anInteger) ifPresent: [ :msg | msg value ]
+    ]
+
+    whenWidgetIsVisible: aWidget send: aSymbol to: anObject [
+	<category: 'notebook events'>
+
+	widgetEvents at: aWidget mainWidget put: (DirectedMessage receiver: anObject selector: aSymbol arguments: #())
+    ]
+]
+
diff --git a/packages/visualgst/Widget/Text/GtkFindWidget.st b/packages/visualgst/Widget/Text/GtkFindWidget.st
new file mode 100644
index 0000000..7a9df19
--- /dev/null
+++ b/packages/visualgst/Widget/Text/GtkFindWidget.st
@@ -0,0 +1,125 @@
+"======================================================================
+|
+| GtkFindWidget class definition
+|
+======================================================================"
+
+"======================================================================
+|
+| Copyright (c) 2013
+| Gwenael Casaccio <gwenael.casaccio@gmail.com>,
+|
+|
+| This file is part of VisualGST.
+|
+| Permission is hereby granted, free of charge, to any person obtaining
+| a copy of this software and associated documentation files (the
+| 'Software'), to deal in the Software without restriction, including
+| without limitation the rights to use, copy, modify, merge, publish,
+| distribute, sublicense, and/or sell copies of the Software, and to
+| permit persons to whom the Software is furnished to do so, subject to
+| the following conditions:
+|
+| The above copyright notice and this permission notice shall be
+| included in all copies or substantial portions of the Software.
+|
+| THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
+| EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
+| MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
+| IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
+| CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
+| TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
+| SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
+|
+======================================================================"
+
+GtkTextPluginWidget subclass: GtkFindWidget [
+    | entry matchCase next previous lastPosition |
+
+    buildEntry [
+	<category: 'user interface'>
+
+	^ entry := GTK.GtkEntry new
+			connectSignal: 'activate' to: self selector: #keyPressed;
+			yourself
+    ]
+
+    buildPreviousButton [
+	<category: 'user interface'>
+
+        ^ previous := GTK.GtkButton previousButton
+			connectSignal: 'clicked' to: self selector: #previousPressed;
+			yourself
+    ]
+
+    buildNextButton [
+        <category: 'user interface'>
+
+        ^ next := GTK.GtkButton nextButton
+			connectSignal: 'clicked' to: self selector: #keyPressed;
+			yourself
+    ]
+
+    buildMatchCaseButton [
+        <category: 'user interface'>
+
+	^ matchCase := GTK.GtkCheckButton newWithLabel: 'match case'
+    ]
+
+    hBox [
+	<category: 'user interface'>
+
+	^ super hBox
+	    packStart: (Label text: 'Find:') mainWidget expand: false fill: false padding: 2;
+	    packStart: self buildEntry expand: false fill: false padding: 15;
+	    packStart: self buildPreviousButton expand: false fill: false padding: 0; 
+	    packStart: self buildNextButton expand: false fill: false padding: 0;
+	    packStart: self buildMatchCaseButton expand: false fill: false padding: 0;
+	    yourself
+    ]
+
+    grabFocus [
+	<category: 'focus'>
+
+	entry grabFocus
+    ]
+
+    searchFrom: anInteger [
+	<category: 'text searching'>
+
+	^ textWidget text indexOf: entry getText matchCase: matchCase getActive startingAt: anInteger
+    ]
+
+    searchBackFrom: anInteger [
+	<category: 'text searching'>
+
+	^ textWidget text deindexOf: entry getText matchCase: matchCase getActive startingAt: anInteger
+    ]
+
+    keyPressed [
+	<category: 'entry events'>
+
+	| int |
+	lastPosition := textWidget hasSelection 
+					ifTrue: [ textWidget cursorPosition + 2 ]
+					ifFalse: [ textWidget cursorPosition + 1 ].
+	lastPosition > textWidget text size ifTrue: [ lastPosition := 1 ].
+	int := self searchFrom: lastPosition.
+	int ifNil: [ (int := self searchFrom: 1) ifNil: [ int := textWidget cursorPosition + 1 to: textWidget cursorPosition ] ].
+	textWidget selectRange: int first - 1 bound: int last.
+    ]
+
+    previousPressed [
+	<category: 'previous events'>
+
+	| int |
+	lastPosition := textWidget hasSelection 
+					ifTrue: [ textWidget cursorPosition ]
+					ifFalse: [ textWidget cursorPosition + 1 ].
+	lastPosition = 0 ifTrue: [ lastPosition := textWidget text size ].
+	int := self searchBackFrom: lastPosition.
+	int ifNil: [ (int := self searchBackFrom: textWidget text size) ifNil: [ int := textWidget cursorPosition + 1 to: textWidget cursorPosition ] ].
+	textWidget selectRange: int first - 1 bound: int last.
+    ]
+]
+
